(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-copypaste', ['exports', '@angular/core', '@angular/common'], factory) :
    (global = global || self, factory(global['ngx-copypaste'] = {}, global.ng.core, global.ng.common));
}(this, function (exports, core, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    var NgxCopyPasteDirective = /** @class */ (function () {
        function NgxCopyPasteDirective(_elementRef) {
            this._elementRef = _elementRef;
        }
        NgxCopyPasteDirective.prototype.copy = function () {
            var select = window.getSelection();
            if (select) {
                select.removeAllRanges();
            }
            var element = this._elementRef.nativeElement;
            if (element instanceof HTMLInputElement ||
                element instanceof HTMLTextAreaElement) {
                this._elementRef.nativeElement.select();
            }
            else {
                var range = document.createRange();
                range.selectNodeContents(this._elementRef.nativeElement);
                select = window.getSelection();
                if (select) {
                    select.addRange(range);
                }
            }
            document.execCommand('copy');
        };
        NgxCopyPasteDirective = __decorate([
            core.Directive({
                selector: '[ngxCopyPaste]',
                exportAs: 'copy'
            }),
            __metadata("design:paramtypes", [core.ElementRef])
        ], NgxCopyPasteDirective);
        return NgxCopyPasteDirective;
    }());

    var NgxCopyPasteModule = /** @class */ (function () {
        function NgxCopyPasteModule() {
        }
        NgxCopyPasteModule = __decorate([
            core.NgModule({
                declarations: [NgxCopyPasteDirective],
                imports: [
                    common.CommonModule
                ],
                exports: [NgxCopyPasteDirective]
            })
        ], NgxCopyPasteModule);
        return NgxCopyPasteModule;
    }());

    exports.NgxCopyPasteDirective = NgxCopyPasteDirective;
    exports.NgxCopyPasteModule = NgxCopyPasteModule;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-copypaste.umd.js.map
