import { __decorate, __metadata } from 'tslib';
import { Directive, ElementRef, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

let NgxCopyPasteDirective = class NgxCopyPasteDirective {
    constructor(_elementRef) {
        this._elementRef = _elementRef;
    }
    copy() {
        let select = window.getSelection();
        if (select) {
            select.removeAllRanges();
        }
        const element = this._elementRef.nativeElement;
        if (element instanceof HTMLInputElement ||
            element instanceof HTMLTextAreaElement) {
            this._elementRef.nativeElement.select();
        }
        else {
            const range = document.createRange();
            range.selectNodeContents(this._elementRef.nativeElement);
            select = window.getSelection();
            if (select) {
                select.addRange(range);
            }
        }
        document.execCommand('copy');
    }
};
NgxCopyPasteDirective = __decorate([
    Directive({
        selector: '[ngxCopyPaste]',
        exportAs: 'copy'
    }),
    __metadata("design:paramtypes", [ElementRef])
], NgxCopyPasteDirective);

let NgxCopyPasteModule = class NgxCopyPasteModule {
};
NgxCopyPasteModule = __decorate([
    NgModule({
        declarations: [NgxCopyPasteDirective],
        imports: [
            CommonModule
        ],
        exports: [NgxCopyPasteDirective]
    })
], NgxCopyPasteModule);

export { NgxCopyPasteDirective, NgxCopyPasteModule };
//# sourceMappingURL=ngx-copypaste.js.map
