import { __decorate, __metadata } from 'tslib';
import { Directive, ElementRef, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

var NgxCopyPasteDirective = /** @class */ (function () {
    function NgxCopyPasteDirective(_elementRef) {
        this._elementRef = _elementRef;
    }
    NgxCopyPasteDirective.prototype.copy = function () {
        var select = window.getSelection();
        if (select) {
            select.removeAllRanges();
        }
        var element = this._elementRef.nativeElement;
        if (element instanceof HTMLInputElement ||
            element instanceof HTMLTextAreaElement) {
            this._elementRef.nativeElement.select();
        }
        else {
            var range = document.createRange();
            range.selectNodeContents(this._elementRef.nativeElement);
            select = window.getSelection();
            if (select) {
                select.addRange(range);
            }
        }
        document.execCommand('copy');
    };
    NgxCopyPasteDirective = __decorate([
        Directive({
            selector: '[ngxCopyPaste]',
            exportAs: 'copy'
        }),
        __metadata("design:paramtypes", [ElementRef])
    ], NgxCopyPasteDirective);
    return NgxCopyPasteDirective;
}());

var NgxCopyPasteModule = /** @class */ (function () {
    function NgxCopyPasteModule() {
    }
    NgxCopyPasteModule = __decorate([
        NgModule({
            declarations: [NgxCopyPasteDirective],
            imports: [
                CommonModule
            ],
            exports: [NgxCopyPasteDirective]
        })
    ], NgxCopyPasteModule);
    return NgxCopyPasteModule;
}());

export { NgxCopyPasteDirective, NgxCopyPasteModule };
//# sourceMappingURL=ngx-copypaste.js.map
